/***************************************************************************
                          filemenu.c  -  description                              
                             -------------------                                         
    begin                : Fri Aug 20 1999                                           
    copyright            : (C) 1999 by Yarick Rastrigin                         
    email                : yarick@relex.ru                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <X11/X.h>
#include <unistd.h>
#include <string.h>

#include "common.h"
#include "gvfs.h"
#ifdef __DEBUG__
#include "debug.h"
#endif /* __DEBUG__ */
#include "filemenu.h"
#include "config.h"
#include "tree.h"
#include "addons.h"
#include "rq.h"

gint
clickhook (GtkWidget * widget, GdkEvent * event, gpointer data)
{
  switch (event->type)
    {
    case GDK_BUTTON_PRESS:
      if (event->button.button == Button2)
	show_file_menu (widget, data);
      break;
    case GDK_2BUTTON_PRESS:
      if (event->button.button == Button1)
	open_object (widget, data);
      break;
    default:
#ifdef __DEBUG__
      debug_out ("This event must not be catched");
      dbgprintf ("%d\n", event->type);
#endif
      break;
    };
  return TRUE;
};


void
show_file_menu (GtkWidget * widget, gpointer data)
{
}

void
open_object (GtkWidget * widget, gpointer data)
{
  gchar *hgc1, *hgc2;
  GfbTypeDef *hGTD1;
  hgc1 = GFB_stddefs[(UNI_ITEM (data)->type) & 0x3F];
  if ((UNI_ITEM(data)->type & 0x3F) == FILE_LIST_FILE)
        {
                if ((UNI_ITEM(data)->type) & GFB_EXECUTABLE)
                hGTD1 = find_typedef("GFB_EXECUTABLE");
                    else
                hGTD1 = find_typedef_by_substr(FILE_INFO(UNI_ITEM(data)->data)->name);
                if (!hGTD1)
                    hGTD1 = find_typedef("FILE_LIST_FILE");
        }
        else
        hGTD1 = find_typedef (hgc1);
  if (!hGTD1)
    return;
  hgc2 = find_action (hGTD1, "Open");
  if (!hgc2)
    return;
  process_action (hgc2, UNI_ITEM (data));
}

void
process_action (gchar * action, UniversalItem * item)
{
  gchar *hgc1, *hgc2, *hgc3, *hgc4, *hgc5;
  if ((item->type & 0x3f) < FILE_LIST_DIR)
    hgc1 = g_strdup (item->data);
  else if ((item->type & 0x3f) < GFB_LAST_TYPEDEF)
    hgc1 = g_strdup (FILE_INFO (item->data)->name);
  else
    return;
  hgc4 = gvfs_get_current_dir ();
  hgc5 = g_malloc0 (strlen (hgc1) + strlen (hgc4) + 2);
  strcpy (hgc5, hgc4);
  append_slash (hgc5);
  strcat (hgc5, hgc1);
  hgc2 = replace_pattern (action, "%f", hgc5);
  hgc3 = strchr (hgc2, ' ');
  *(hgc3++) = '\0';
  g_free(hgc4);g_free(hgc5);hgc3 = g_strdup(hgc3);
  /* so we've divided the whole string to COMMAND (hgc2) and PARAMETERS (hgc3) */
  if (!strcmp (hgc2, "GFB_CD"))
    {
      /* CD to dir */
      putRequest (MAKE_DIR_LIST, hgc3, NULL);
      putRequest (EXPAND_TREE, hgc3, NULL);
    }
  else if (!strcmp (hgc2, "GFB_OPEN_WITH"))
    {
      /* Open with... dialog */
    }
  else if (!strcmp (hgc2, "GFB_SYMLINK_TO"))
    {
      /* Symlink to... dialog */
    }
  else if (!strcmp (hgc2, "GFB_EXEC"))
    {
        /* Execute */
      debug_out(hgc3);
      putRequest(EXECUTE, hgc3, NULL);
    }
  else
    /* run external command */
    {
      putRequest(EXECUTE, hgc3, NULL);
    };
  g_free (hgc1);
  g_free (hgc2);
}









